package de.wwwu.awolf.model.dao;

import java.util.HashSet;
import java.util.Set;

/**
 * Implementierung verschiedener Algorithmen zur Berechnung von Ausgleichsgeraden.
 *
 * @Author: Armin Wolf
 * @Email: a_wolf28@uni-muenster.de
 * @Date: 28.05.2017.
 */
public class LineModel {

    private Double max;
    private Double min;

    private Set<Line> lines;
    private int size;

    /**
     * Konstruktor
     */
    public LineModel() {
        lines = new HashSet<>();
        size = 0;

        min = 0d;
        max = 0d;
    }


    /**
     * Fügt eine Gerade zu dem Modell hinzu
     *
     * @param line Gerade
     */
    public void addLine(Line line) {
        this.lines.add(line);
        min = line.getM() <= min ? line.getM() : min;
        max = line.getM() >= max ? line.getM() : max;
    }

    public Double getMin() {
        return min;
    }

    public Double getMax() {
        return max;
    }

    /**
     * @return Liste der Geraden
     */
    public Set<Line> getLines() {
        return lines;
    }

    /**
     * @param lines Liste der Geraden
     */
    public void setLines(Set<Line> lines) {
        lines.forEach(this::addLine);
        this.size = lines.size();
    }

    public int getSize() {
        return size;
    }
}
